<?php
/**
 * @package		HikaShop for Joomla!
 * @version		1.5.4
 * @author		hikashop.com
 * @copyright	(C) 2010-2011 HIKARI SOFTWARE. All rights reserved.
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?>
<?php
class hikashopDiscountClass extends hikashopClass{
	var $tables = array('discount');
	var $pkeys = array('discount_id');
	var $namekeys = array('');
	var $toggle = array('discount_published'=>'discount_id');
	function saveForm(){
		$discount = null;
		$discount->discount_id = hikashop_getCID('discount_id');
		$formData = JRequest::getVar( 'data', array(), '', 'array' );
		foreach($formData['discount'] as $column => $value){
			hikashop_secureField($column);
			$discount->$column = strip_tags($value);
		}
		if(!empty($discount->discount_start)){
			$discount->discount_start=hikashop_getTime($discount->discount_start);
		}
		if(!empty($discount->discount_end)){
			$discount->discount_end=hikashop_getTime($discount->discount_end);
		}
		$status = $this->save($discount);
		return $status;
	}
	function save(&$discount){
		if(empty($discount->discount_id)){
			if(empty($discount->discount_type) || ($discount->discount_type=='coupon' && empty($discount->discount_code))){
				return false;
			}
		}
		$status = parent::save($discount);
		return $status;
	}
	function load($coupon){
		static $coupons = array();
		if(!isset($coupons[$coupon])){
			$filters = array('discount_code='.$this->database->Quote($coupon),'discount_type=\'coupon\'','discount_published=1');
			$query = 'SELECT * FROM '.hikashop_table('discount').' WHERE '.implode(' AND ',$filters);
			$this->database->setQuery($query);
			$coupons[$coupon] = $this->database->loadObject();
		}
		return $coupons[$coupon];
	}
	function loadAndCheck($coupon_code,&$total,$zones,&$products,$display_error=true){
		$coupon = $this->load($coupon_code);
		return $this->check($coupon,$total,$zones,$products,$display_error);
	}
	function check(&$coupon,&$total,$zones,&$products,$display_error=true){
		$user = hikashop_get('class.user');
		$currency = hikashop_get('class.currency');
		$error_message = '';
		if(empty($coupon)){
			$error_message = JText::_('COUPON_NOT_VALID');
		}elseif($coupon->discount_start>time()){
			$error_message = JText::_('COUPON_NOT_YET_USABLE');
		}elseif($coupon->discount_end && $coupon->discount_end<time()){
			$error_message = JText::_('COUPON_EXPIRED');
		}else{
			if(hikashop_level(2)){
				if(!empty($coupon->discount_access)){
					$my =& JFactory::getUser();
					if($coupon->discount_access != 'all' AND ($coupon->discount_access == 'none' OR empty($my->id) OR !hikashop_isAllowed($coupon->discount_access))){
			    		$error_message = JText::_('COUPON_NOT_FOR_YOU');
			    	}
				}
			}
			if(empty($error_message) && hikashop_level(1)){
				if(!empty($coupon->discount_quota) && $coupon->discount_quota<=$coupon->discount_used_times){
					$error_message = JText::_('QUOTA_REACHED_FOR_COUPON');
				}else{
					if(!empty($coupon->discount_quota_per_user)){
						$user_id = hikashop_loadUser();
						if($user_id){
							$db =& JFactory::getDBO();
							$config =& hikashop_config();
							$cancelled_order_status = explode(',',$config->get('cancelled_order_status'));
							$cancelled_order_status = "'".implode("','",$cancelled_order_status)."'";
							$query = 'SELECT COUNT(order_id) AS already_used FROM '.hikashop_table('order').' WHERE order_user_id='.(int)$user_id.' AND order_status NOT IN ('.$cancelled_order_status.') AND order_discount_code='.$db->Quote($coupon->discount_code).' GROUP BY order_id';
							$db->setQuery($query);
							$already_used = $db->loadResult();
							if($coupon->discount_quota_per_user<=$already_used){
								$error_message = JText::_('QUOTA_REACHED_FOR_COUPON');
							}
						}
					}
					if(empty($error_message)){
						if($coupon->discount_zone_id){
							$class = hikashop_get('class.zone');
							$zone = $class->get($coupon->discount_zone_id);
							if(!in_array($zone->zone_namekey,$zones)){
								$error_message = JText::_('COUPON_NOT_AVAILABLE_IN_YOUR_ZONE');
							}
						}
					}
					$ids = array();
					$qty = 0;
					foreach($products as $prod){
						$qty+=$prod->cart_product_quantity;
						$ids[$prod->product_id]=$prod->product_id;
						if(!empty($prod->product_parent_id)) $ids[$prod->product_parent_id]=$prod->product_parent_id;
					}
					if(empty($error_message) && $coupon->discount_product_id){
						if(!in_array($coupon->discount_product_id,$ids)){
							$error_message = JText::_('COUPON_NOT_FOR_THOSE_PRODUCTS');
						}
					}
					if(empty($error_message) && $coupon->discount_category_id){
						$database =& JFactory::getDBO();
						if($coupon->discount_category_childs){
							$categoryClass = hikashop_get('class.category');
							$category = $categoryClass->get((int)$coupon->discount_category_id);
							$filters = array('b.category_left >= '.$category->category_left ,'b.category_right <= '.$category->category_right,'b.category_published=1','b.category_type=\'product\'','a.product_id IN ('.implode(',',$ids).')');
							hikashop_addACLFilters($filters,'category_access','b');
							$select = 'SELECT a.product_id FROM '.hikashop_table('category').' AS b LEFT JOIN '.hikashop_table('product_category').' AS a ON b.category_id=a.category_id WHERE '.implode(' AND ',$filters);
						}else{
							$filters = array('b.category_id = '.(int)$coupon->discount_category_id ,'a.product_id IN ('.implode(',',$ids).')');
							hikashop_addACLFilters($filters,'category_access','b');
							$select = 'SELECT a.product_id FROM '.hikashop_table('category').' AS b LEFT JOIN '.hikashop_table('product_category').' AS a ON b.category_id=a.category_id WHERE '.implode(' AND ',$filters);
						}
						$database->setQuery($select);
						$id = $database->loadResult();
						if(!$id){
							$error_message = JText::_('COUPON_NOT_FOR_PRODUCTS_IN_THOSE_CATEGORIES');
						}
					}
					if(empty($error_message) && bccomp($coupon->discount_minimum_order,0,5)){
						$currency->convertCoupon($coupon,$total->prices[0]->price_currency_id);
						$config =& hikashop_config();
						$discount_before_tax = $config->get('discount_before_tax');
						$var = 'price_value_with_tax';
						if(!$discount_before_tax){
							$var = 'price_value';
						}
						if($coupon->discount_minimum_order>$total->prices[0]->$var){
							$error_message = JText::sprintf('ORDER_NOT_EXPENSIVE_ENOUGH_FOR_COUPON',$currency->format($coupon->discount_minimum_order,$coupon->discount_currency_id));
						}
					}
					if(empty($error_message) && $coupon->discount_minimum_products){
						if($coupon->discount_minimum_products>$qty){
							$error_message = JText::sprintf('NOT_ENOUGH_PRODUCTS_FOR_COUPON',$coupon->discount_minimum_products);
						}
					}
				}
			}
		}
		if(!empty($error_message)){
			$class = hikashop_get('class.cart');
			$class->update('',0,0,'coupon');
			if($display_error){
				JRequest::setVar('coupon_error_message',$error_message);
			}
			return null;
		}
		JRequest::setVar('coupon_error_message','');
		$currency->convertCoupon($coupon,$total->prices[0]->price_currency_id);
		if(PHP_VERSION < 5){
			$coupon->total = $total;
		}else{
			$coupon->total->prices = array(clone(reset($total->prices)));
		}
		$currency->addCoupon($coupon->total,$coupon);
		return $coupon;
	}
}